---
title: HTMLMediaElement
slug: Web/API/HTMLMediaElement
tags:
  - API
  - Audio
  - HTML
  - HTML DOM
  - HTMLMediaElement
  - Interface
  - Media
  - Reference
  - Video
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">The <strong><code>HTMLMediaElement</code></strong> interface adds to {{domxref("HTMLElement")}} the properties and methods needed to support basic media-related capabilities that are common to audio and video.</span> The {{domxref("HTMLVideoElement")}} and {{domxref("HTMLAudioElement")}} elements both inherit this interface.</p>

<p>{{InheritanceDiagram(600, 180)}}</p>

<h2 id="Properties">Properties</h2>

<p><em>This interface also inherits properties from its ancestors {{domxref("HTMLElement")}}, {{domxref("Element")}}, {{domxref("Node")}}, and {{domxref("EventTarget")}}.</em></p>

<dl>
 <dt>{{domxref("HTMLMediaElement.audioTracks")}}</dt>
 <dd>A {{domxref("AudioTrackList")}} that lists the {{domxref("AudioTrack")}} objects contained in the element.</dd>
 <dt>{{domxref("HTMLMediaElement.autoplay")}}</dt>
 <dd>
 <p>A {{jsxref("Boolean")}} that reflects the {{htmlattrxref("autoplay", "video")}} HTML attribute, indicating whether playback should automatically begin as soon as enough media is available to do so without interruption.</p>

 <div class="note"><strong>Note</strong>: Automatically playing audio when the user doesn't expect or desire it is a poor user experience and should be avoided in most cases, though there are exceptions. See the <a href="/en-US/docs/Web/Media/Autoplay_guide">Autoplay guide for media and Web Audio APIs</a> for more information. Keep in mind that browsers may ignore autoplay requests, so you should ensure that your code isn't dependent on autoplay working.</div>
 </dd>
 <dt>{{domxref("HTMLMediaElement.buffered")}} {{readonlyinline}}</dt>
 <dd>Returns a {{domxref("TimeRanges")}} object that indicates the ranges of the media source that the browser has buffered (if any) at the moment the <code>buffered</code> property is accessed.</dd>
 <dt>{{domxref("HTMLMediaElement.controller")}}</dt>
 <dd>Is a {{domxref("MediaController")}} object that represents the media controller assigned to the element, or <code>null</code> if none is assigned.</dd>
 <dt>{{domxref("HTMLMediaElement.controls")}}</dt>
 <dd>Is a {{jsxref('Boolean')}} that reflects the {{htmlattrxref("controls", "video")}} HTML attribute, indicating whether user interface items for controlling the resource should be displayed.</dd>
 <dt>{{domxref("HTMLMediaElement.controlsList")}} {{readonlyinline}}</dt>
 <dd>Returns a {{domxref("DOMTokenList")}} that helps the user agent select what controls to show on the media element whenever the user agent shows its own set of controls. The <code>DOMTokenList</code> takes one or more of three possible values: <code>nodownload</code>, <code>nofullscreen</code>, and <code>noremoteplayback</code>.</dd>
 <dt>{{domxref("HTMLMediaElement.crossOrigin")}}</dt>
 <dd>A {{domxref("DOMString")}} indicating the <a href="/en-US/docs/Web/HTML/CORS_settings_attributes">CORS setting</a> for this media element.</dd>
 <dt>{{domxref("HTMLMediaElement.currentSrc")}} {{readonlyinline}}</dt>
 <dd>Returns a {{domxref("DOMString")}} with the absolute URL of the chosen media resource.</dd>
 <dt>{{domxref("HTMLMediaElement.currentTime")}}</dt>
 <dd>A double-precision floating-point value indicating the current playback time in seconds; if the media has not started to play and has not been seeked, this value is the media's initial playback time. Setting this value seeks the media to the new time. The time is specified relative to the media's timeline.</dd>
 <dt>{{domxref("HTMLMediaElement.defaultMuted")}}</dt>
 <dd>A {{jsxref('Boolean')}} that reflects the {{htmlattrxref("muted", "video")}} HTML attribute, which indicates whether the media element's audio output should be muted by default.</dd>
 <dt>{{domxref("HTMLMediaElement.defaultPlaybackRate")}}</dt>
 <dd>A <code>double</code> indicating the default playback rate for the media.</dd>
 <dt>{{domxref("HTMLMediaElement.disableRemotePlayback")}}</dt>
 <dd>A {{jsxref('Boolean')}} that sets or returns the remote playback state, indicating whether the media element is allowed to have a remote playback UI.</dd>
 <dt>{{domxref("HTMLMediaElement.duration")}} {{readonlyinline}}</dt>
 <dd>A read-only double-precision floating-point value indicating the total duration of the media in seconds. If no media data is available, the returned value is <code>NaN</code>. If the media is of indefinite length (such as streamed live media, a WebRTC call's media, or similar), the value is <code>+Infinity</code>.</dd>
 <dt>{{domxref("HTMLMediaElement.ended")}} {{readonlyinline}}</dt>
 <dd>Returns a {{jsxref('Boolean')}} that indicates whether the media element has finished playing.</dd>
 <dt>{{domxref("HTMLMediaElement.error")}} {{readonlyinline}}</dt>
 <dd>Returns a {{domxref("MediaError")}} object for the most recent error, or <code>null</code> if there has not been an error.</dd>
 <dt>{{domxref("HTMLMediaElement.loop")}}</dt>
 <dd>A {{jsxref('Boolean')}} that reflects the {{htmlattrxref("loop", "video")}} HTML attribute, which indicates whether the media element should start over when it reaches the end.</dd>
 <dt>{{domxref("HTMLMediaElement.mediaGroup")}}</dt>
 <dd>A {{domxref("DOMString")}} that reflects the {{ htmlattrxref("mediagroup", "video")}} HTML attribute, which indicates the name of the group of elements it belongs to. A group of media elements shares a common {{domxref('MediaController')}}.</dd>
 <dt>{{domxref("HTMLMediaElement.mediaKeys")}} {{readonlyinline}} {{experimental_inline}}</dt>
 <dd>Returns a {{domxref("MediaKeys")}} object or <code>null</code>. MediaKeys is a set of keys that an associated HTMLMediaElement can use for decryption of media data during playback.</dd>
 <dt>{{domxref("HTMLMediaElement.muted")}}</dt>
 <dd>Is a {{jsxref('Boolean')}} that determines whether audio is muted. <code>true</code> if the audio is muted and <code>false</code> otherwise.</dd>
 <dt>{{domxref("HTMLMediaElement.networkState")}} {{readonlyinline}}</dt>
 <dd>Returns a <code>unsigned short</code> (enumeration) indicating the current state of fetching the media over the network.</dd>
 <dt>{{domxref("HTMLMediaElement.paused")}} {{readonlyinline}}</dt>
 <dd>Returns a {{jsxref('Boolean')}} that indicates whether the media element is paused.</dd>
 <dt>{{domxref("HTMLMediaElement.playbackRate")}}</dt>
 <dd>Is a <code>double</code> that indicates the rate at which the media is being played back.</dd>
 <dt>{{domxref("HTMLMediaElement.played")}} {{readonlyinline}}</dt>
 <dd>Returns a {{domxref('TimeRanges')}} object that contains the ranges of the media source that the browser has played, if any.</dd>
 <dt>{{domxref("HTMLMediaElement.preload")}}</dt>
 <dd>Is a {{domxref("DOMString")}} that reflects the {{htmlattrxref("preload", "video")}} HTML attribute, indicating what data should be preloaded, if any. Possible values are: <code>none</code>, <code>metadata</code>, <code>auto</code>.</dd>
 <dt>{{domxref("HTMLMediaElement.preservesPitch")}} {{non-standard_inline}}</dt>
 <dd>Is a {{jsxref('Boolean')}} that determines if the pitch of the sound will be preserved. If set to <code>false</code>, the pitch will adjust to the speed of the audio. This is implemented with prefixes in Firefox (<code>mozPreservesPitch</code>) and WebKit (<code>webkitPreservesPitch</code>).</dd>
 <dt>{{domxref("HTMLMediaElement.readyState")}} {{readonlyinline}}</dt>
 <dd>Returns a <code>unsigned short</code> (enumeration) indicating the readiness state of the media.</dd>
 <dt>{{domxref("HTMLMediaElement.seekable")}} {{readonlyinline}}</dt>
 <dd>Returns a {{domxref('TimeRanges')}} object that contains the time ranges that the user is able to seek to, if any.</dd>
 <dt>{{domxref("HTMLMediaElement.seeking")}} {{readonlyinline}}</dt>
 <dd>Returns a {{jsxref('Boolean')}} that indicates whether the media is in the process of seeking to a new position.</dd>
 <dt>{{domxref("HTMLMediaElement.sinkId")}} {{readonlyinline}} {{experimental_inline}}</dt>
 <dd>Returns a {{domxref("DOMString")}} that is the unique ID of the audio device delivering output, or an empty string if it is using the user agent default. This ID should be one of the <code>MediaDeviceInfo.deviceid</code> values returned from {{domxref("MediaDevices.enumerateDevices()")}}, <code>id-multimedia</code>, or <code>id-communications</code>.</dd>
 <dt>{{domxref("HTMLMediaElement.src")}}</dt>
 <dd>Is a {{domxref("DOMString")}} that reflects the {{htmlattrxref("src", "video")}} HTML attribute, which contains the URL of a media resource to use.</dd>
 <dt>{{domxref("HTMLMediaElement.srcObject")}}</dt>
 <dd>Is a {{domxref('MediaStream')}} representing the media to play or that has played in the current <code>HTMLMediaElement</code>, or <code>null</code> if not assigned.</dd>
 <dt>{{domxref("HTMLMediaElement.textTracks")}} {{readonlyinline}}</dt>
 <dd>Returns the list of {{domxref("TextTrack")}} objects contained in the element.</dd>
 <dt>{{domxref("HTMLMediaElement.videoTracks")}} {{readonlyinline}}</dt>
 <dd>Returns the list of {{domxref("VideoTrack")}} objects contained in the element.</dd>
 <dt>{{domxref("HTMLMediaElement.volume")}}</dt>
 <dd>Is a <code>double</code> indicating the audio volume, from 0.0 (silent) to 1.0 (loudest).</dd>
</dl>

<h3 id="Event_handlers">Event handlers</h3>

<dl>
 <dt>{{domxref("HTMLMediaElement.onencrypted")}}</dt>
 <dd>Sets the {{domxref('EventHandler')}} called when the media is encrypted.</dd>
 <dt>{{domxref("HTMLMediaElement.onwaitingforkey")}}</dt>
 <dd>Sets the {{domxref('EventHandler')}} called when playback is blocked while waiting for an encryption key.</dd>
</dl>

<h2 id="Obsolete_attributes">Obsolete attributes</h2>

<p>These attributes are obsolete and should not be used, even if a browser still supports them.</p>

<dl>
 <dt>{{domxref("HTMLMediaElement.initialTime")}} {{readonlyinline}} {{non-standard_inline}} {{obsolete_inline}}</dt>
 <dd>Returns a <code>double</code> that indicates the initial playback position in seconds.</dd>
 <dt>{{domxref("HTMLMediaElement.mozAudioCaptured")}} {{readonlyinline}} {{non-standard_inline}}</dt>
 <dd>Returns a {{jsxref('Boolean')}}. Related to audio stream capture.</dd>
 <dt>{{domxref("HTMLMediaElement.mozChannels")}} {{readonlyinline}} {{non-standard_inline}} {{deprecated_inline}}</dt>
 <dd>Returns a <code>double</code> representing the number of channels in the audio resource (e.g., <code>2</code> for stereo).</dd>
 <dt>{{domxref("HTMLMediaElement.mozFragmentEnd")}} {{non-standard_inline}}</dt>
 <dd>Is a <code>double</code> that provides access to the fragment end time if the media element has a fragment URI for <code>currentSrc</code>, otherwise it is equal to the media duration.</dd>
 <dt>{{domxref("HTMLMediaElement.mozFrameBufferLength")}} {{non-standard_inline}} {{deprecated_inline}}</dt>
 <dd>
 <p>Is a <code>unsigned long</code> that indicates the number of samples that will be returned in the framebuffer of each <code>MozAudioAvailable</code> event. This number is a total for all channels, and by default is set to be the number of channels * 1024 (e.g., 2 channels * 1024 samples = 2048 total).</p>

 <p>The <code>mozFrameBufferLength</code> property can be set to a new value for lower latency, larger amounts of data, etc. The size given <em>must</em> be a number between 512 and 16384. Using any other size results in an exception being thrown. The best time to set a new length is after the <a href="/en-US/docs/Web/Events/loadedmetadata">loadedmetadata</a> event fires, when the audio info is known, but before the audio has started or <code>MozAudioAvailable</code> events have begun firing.</p>
 </dd>
 <dt>{{domxref("HTMLMediaElement.mozSampleRate")}} {{readonlyinline}} {{non-standard_inline}} {{deprecated_inline}}</dt>
 <dd>Returns a <code>double</code> representing the number of samples per second that will be played. For example, 44100 samples per second is the sample rate used by CD audio.</dd>
</dl>

<h3 id="Obsolete_event_handlers">Obsolete event handlers</h3>

<dl>
 <dt>{{domxref("HTMLMediaElement.onmozinterruptbegin")}} {{non-standard_inline}} {{obsolete_inline}}</dt>
 <dd>Sets the {{domxref("EventHandler")}} called when the media element is interrupted because of the Audio Channel manager. This was Firefox-specific, having been implemented for Firefox OS, and was removed in Firefox 55.</dd>
 <dt>{{domxref("HTMLMediaElement.onmozinterruptend")}} {{non-standard_inline}} {{obsolete_inline}}</dt>
 <dd>Sets the {{domxref('EventHandler')}} called when the interruption is concluded. This was Firefox-specific, having been implemented for Firefox OS, and was removed in Firefox 55.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>This interface also inherits methods from its ancestors {{domxref("HTMLElement")}}, {{domxref("Element")}}, {{domxref("Node")}}, and {{domxref("EventTarget")}}.</em></p>

<dl>
 <dt>{{domxref("HTMLMediaElement.addTextTrack()")}}</dt>
 <dd>Adds a text track (such as a track for subtitles) to a media element.</dd>
 <dt>{{domxref("HTMLMediaElement.captureStream()")}} {{experimental_inline}}</dt>
 <dd>Returns {{domxref("MediaStream")}}, captures a stream of the media content.</dd>
 <dt>{{domxref("HTMLMediaElement.canPlayType()")}}</dt>
 <dd>Given a string specifying a MIME media type (potentially with the <a href="/en-US/docs/Web/Media/Formats/codecs_parameter"><code>codecs</code> parameter</a> included), <code>canPlayType()</code> returns the string <code>probably</code> if the media should be playable, <code>maybe</code> if there's not enough information to determine whether the media will play or not, or an empty string if the media cannot be played.</dd>
 <dt>{{domxref("HTMLMediaElement.fastSeek()")}}</dt>
 <dd>Directly seeks to the given time.</dd>
 <dt>{{domxref("HTMLMediaElement.load()")}}</dt>
 <dd>Resets the media to the beginning and selects the best available source from the sources provided using the {{htmlattrxref("src", "video")}} attribute or the {{HTMLElement("source")}} element.</dd>
 <dt>{{domxref("HTMLMediaElement.pause()")}}</dt>
 <dd>Pauses the media playback.</dd>
 <dt>{{domxref("HTMLMediaElement.play()")}}</dt>
 <dd>Begins playback of the media.</dd>
 <dt>{{domxref("HTMLMediaElement.seekToNextFrame()")}} {{non-standard_inline}} {{experimental_inline}}</dt>
 <dd>Seeks to the next frame in the media. This non-standard, experimental method makes it possible to manually drive reading and rendering of media at a custom speed, or to move through the media frame-by-frame to perform filtering or other operations.</dd>
 <dt>{{domxref("HTMLMediaElement.setMediaKeys()")}} {{experimental_inline}}</dt>
 <dd>Returns {{jsxref("Promise")}}. Sets the {{domxref("MediaKeys")}} keys to use when decrypting media during playback.</dd>
 <dt>{{domxref("HTMLMediaElement.setSinkId()")}} {{experimental_inline}}</dt>
 <dd>Sets the ID of the audio device to use for output and returns a {{jsxref("Promise")}}. This only works when the application is authorized to use the specified device.</dd>
</dl>

<h2 id="Obsolete_methods">Obsolete methods</h2>

<p><em>These methods are obsolete and should not be used, even if a browser still supports them.</em></p>

<dl>
 <dt>{{domxref("HTMLMediaElement.mozCaptureStream()")}} {{non-standard_inline}}</dt>
 <dd>[enter description]</dd>
 <dt>{{domxref("HTMLMediaElement.mozCaptureStreamUntilEnded()")}} {{non-standard_inline}}</dt>
 <dd>[enter description]</dd>
 <dt>{{domxref("HTMLMediaElement.mozGetMetadata()")}} {{non-standard_inline}}</dt>
 <dd>Returns {{jsxref('Object')}}, which contains properties that represent metadata from the playing media resource as <code>{key: value}</code> pairs. A separate copy of the data is returned each time the method is called. This method must be called after the <a href="/en-US/docs/Web/Events/loadedmetadata">loadedmetadata</a> event fires.</dd>
 <dt>{{domxref("HTMLMediaElement.mozLoadFrom()")}} {{non-standard_inline}} {{deprecated_inline}}</dt>
 <dd>This method, available only in Mozilla's implementation, loads data from another media element. This works similarly to <code>load()</code> except that instead of running the normal resource selection algorithm, the source is set to the <code>other</code> element's <code>currentSrc</code>. This is optimized so this element gets access to all of the <code>other</code> element's cached and buffered data; in fact, the two elements share downloaded data, so data downloaded by either element is available to both.</dd>
</dl>

<h2 id="Events">Events</h2>

<p><em>Inherits methods from its parent, {{domxref("HTMLElement")}} </em>, defined in the {{domxref('GlobalEventHandlers')}} mixin. Listen to these events using <code><a href="/en-US/docs/Web/API/EventTarget/addEventListener">addEventListener()</a></code> or by assigning an event listener to the <code>on<em>eventname</em></code> property of this interface.</p>

<dl>
 <dt>{{domxref("HTMLMediaElement.abort_event", 'abort')}}</dt>
 <dd>Fired when the resource was not fully loaded, but not as the result of an error.</dd>
 <dt>{{domxref("HTMLMediaElement.canplay_event", 'canplay')}}</dt>
 <dd>Fired when the user agent can play the media, but estimates that <strong>not</strong> enough data has been loaded to play the media up to its end without having to stop for further buffering of content</dd>
 <dt>{{domxref("HTMLMediaElement.canplaythrough_event", 'canplaythrough')}}</dt>
 <dd>Fired when the user agent can play the media, and estimates that enough data has been loaded to play the media up to its end without having to stop for further buffering of content.</dd>
 <dt>{{domxref("HTMLMediaElement.durationchange_event", 'durationchange')}}</dt>
 <dd>Fired when the duration attribute has been updated.</dd>
 <dt>{{domxref("HTMLMediaElement.emptied_event", 'emptied')}}</dt>
 <dd>Fired when the media has become empty; for example, when the media has already been loaded (or partially loaded), and the {{domxref("HTMLMediaElement.load()")}} method is called to reload it.</dd>
 <dt>{{domxref("HTMLMediaElement.ended_event", 'ended')}}</dt>
 <dd>Fired when playback stops when end of the media (&lt;audio&gt; or &lt;video&gt;) is reached or because no further data is available.</dd>
 <dt>{{domxref("HTMLMediaElement.error_event", 'error')}}</dt>
 <dd>Fired when the resource could not be loaded due to an error.</dd>
 <dt>{{domxref("HTMLMediaElement.loadeddata_event", 'loadeddata')}}</dt>
 <dd>Fired when the first frame of the media has finished loading.</dd>
 <dt>{{domxref("HTMLMediaElement.loadedmetadata_event", 'loadedmetadata')}}</dt>
 <dd>Fired when the metadata has been loaded</dd>
 <dt>{{domxref("HTMLMediaElement.loadstart_event", 'loadstart')}}</dt>
 <dd>Fired when the browser has started to load a resource.</dd>
 <dt>{{domxref("HTMLMediaElement.pause_event", 'pause')}}</dt>
 <dd>Fired when a request to pause play is handled and the activity has entered its paused state, most commonly occurring when the media's {{domxref("HTMLMediaElement.pause()")}} method is called.</dd>
 <dt>{{domxref("HTMLMediaElement.play_event", 'play')}}</dt>
 <dd>Fired when the <code>paused</code> property is changed from <code>true</code> to <code>false</code>, as a result of the {{domxref("HTMLMediaElement.play()")}} method, or the <code>autoplay</code> attribute</dd>
 <dt>{{domxref("HTMLMediaElement.playing_event", "playing")}}</dt>
 <dd>Fired when playback is ready to start after having been paused or delayed due to lack of data</dd>
 <dt>{{domxref("HTMLMediaElement.progress_event", "progress")}}</dt>
 <dd>Fired periodically as the browser loads a resource.</dd>
 <dt>{{domxref("HTMLMediaElement.ratechange_event", 'ratechange')}}</dt>
 <dd>Fired when the playback rate has changed.</dd>
 <dt>{{domxref("HTMLMediaElement.seeked_event", 'seeked ')}}</dt>
 <dd>Fired when a seek operation completes</dd>
 <dt>{{domxref("HTMLMediaElement.seeking_event", 'seeking')}}</dt>
 <dd>Fired when a seek operation begins</dd>
 <dt>{{domxref("HTMLMediaElement.stalled_event", 'stalled')}}</dt>
 <dd>Fired when the user agent is trying to fetch media data, but data is unexpectedly not forthcoming.</dd>
 <dt>{{domxref("HTMLMediaElement.suspend_event", 'suspend')}}</dt>
 <dd>Fired when the media data loading has been suspended.</dd>
 <dt>{{domxref("HTMLMediaElement.timeupdate_event", 'timeupdate')}}</dt>
 <dd>Fired when the time indicated by the {{domxref("HTMLMediaElement.currentTime", "currentTime")}} attribute has been updated.</dd>
 <dt>{{domxref("HTMLMediaElement.volumechange_event", 'volumechange')}}</dt>
 <dd>Fired when the volume has changed.</dd>
 <dt>{{domxref("HTMLMediaElement.waiting_event", 'waiting')}}</dt>
 <dd>Fired when playback has stopped because of a temporary lack of data.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('EME', '#introduction', 'Encrypted Media Extensions')}}</td>
   <td>{{Spec2('EME')}}</td>
   <td>Adds {{domxref("MediaKeys")}}, {{domxref("MediaEncryptedEvent")}}, {{domxref("setMediaKeys")}}, {{domxref("onencrypted")}}, and {{domxref("onwaitingforkey")}}.</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "the-video-element.html#htmlmediaelement", "HTMLMediaElement")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>No change from {{SpecName('HTML5 W3C')}}</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', "embedded-content-0.html#htmlmediaelement", "HTMLMediaElement")}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLMediaElement")}}</p>

<h2 id="See_also">See also</h2>

<h3 id="References">References</h3>

<ul>
 <li>{{HTMLElement("video")}} and {{HTMLElement("audio")}} HTML elements.</li>
 <li>{{domxref("HTMLVideoElement")}} and {{domxref("HTMLAudioElement")}} interfaces, derived from <code>HTMLMediaElement</code>.</li>
</ul>

<h3 id="Guides">Guides</h3>

<ul>
 <li><a href="/en-US/docs/Web/Media">Web media technologies</a></li>
 <li>Learning area: <a href="/en-US/docs/Learn/HTML/Multimedia_and_embedding/Video_and_audio_content">Video and audio content</a></li>
 <li><a href="/en-US/docs/Web/Media/Formats">Guide to media types and formats on the web</a></li>
 <li><a href="/en-US/docs/Web/Media/Formats/Support_issues">Handling media support issues in web content</a></li>
</ul>
